#!/usr/bin/perl

%data = &get_data();
#########################################################################
#####									#
##### Chat-N-Time v2.8							#
##### Copyright 1999, Kristina L. Pfaff-Harris, scripts@tesol.net	#
#####									#
##### A very simple real-time chat program for the web.  Users log 	#
##### in and from then on can type messages in a box that appear	#
##### instantly to others in the "room."  A "refresh" tag insures that	#
##### the conversation keeps getting updated for others.  Uses frames.	#
#####									#
#########################################################################
##### Licensing:							#
#####									#
#####  This program may be used free of charge under the following	#
#####  conditions:							#
#####  									#
#####  1. All instructions and Copyright lines must remain unchanged.	#
#####  2. All pages generated by the program must contain one of the	#
#####     following pieces of HTML code:				#
#####  									#
#####     <font size=-2>Chat-N-Time v2.8 Copyright 2001 by		#
#####     Kristina Pfaff-Harris. It can be found at: 			#
#####     <a href="http://www.tesol.net/scripts/">			#
#####     http://www.tesol.net/scripts</a></font>			#
#####  OR:								#
#####     <!-- Chat-N-Time Copyright 2001 Kristina Pfaff-Harris -->	#
#####     <!-- Get it at http://www.tesol.net/scripts/         -->	#
##### 									#
#####  3. You may not sell or redistribute this program.  This isn't	#
#####     really arbitrary:  I just like to make sure that when people	#
#####     get the script, they get the latest version.  You may charge	#
#####     a reasonable fee for installing it for a client as long as	#
#####     you make it clear that you are not the author, and you are	#
#####     not selling the program to them: only charging for installing	#
#####     it. 								#
#####  4. You agree that this program is offered without warranty of	#
#####     any kind, including warranty of fitness for a particular	#
#####     purpose. You further agree that the author and all sites 	#
#####     associated in any way with this program are not liable for	#
#####     any damage or loss incurred as a result of using this program.#
#########################################################################
#####									#
##### IMPORTANT INSTRUCTIONS:						#
#####									#
##### In this program, I have put **CHANGE** in all the places where	#
##### you will need to modify the program to run on your server, so	#
##### that you can easily find all the places where changes are 	#
##### necessary.  This program must be chmod 755 or 775 in order to	#
##### work, and any html files must be chmod 644.  Note:  on some, 	#
##### systems, you'll have to either make the files "chatters.txt"	#
##### and chatntime.list.html world writeable (chmod 766) or you'll 	#
##### have to make chatntime.cgi run as you (setuid - chmod 4755). 	#
##### This latter isn't always as easy as just chmodding the program.	#
##### Ask your local technical support person if your web server 	#
##### supports setuid Perl scripts.					#
#####									#
##### Please read the README.chatntime file for more instructions	#
##### on how to set this up.  Please read all the instructions below    #
##### carefully as well.						#
#########################################################################

######     Begin Configuration Section ######

# First of all, let's set up to print out some debugging information.
# This can help you figure out what might be going wrong with the
# program if you're not getting it to work quite right.  When you
# have the program set up and functioning, **CHANGE** $debugging = 1;
# to $debugging = 0;

$debugging = 0;

# Now, a few options.  First of all, if you would like chatters to
# be able to enter HTML code which will be rendered on the screen,
# **CHANGE** $disable_html = 1; to $disable_html = 0; Note that if
# you set $disable_html to 0, users will be able to put inline images,
# sounds, links, etc, right into the chat window which sometimes makes
# things confusing and hard to read.

$disable_html = 1;

# $number_of_chats_to_display is just how many lines you want to display
# of the ongoing chat before the program drops one off the end.  For 
# example, if you make this "5", then 5 people will get to say something,
# then when the 6th person says something, the 1st person's statement
# will drop off the list.  **CHANGE** this if you like to something
# longer or shorter.

$number_of_chats_to_display = "15";

# $clear_chatroom_when_empty is whether or not you want to clear out
# all the old chats when the last person leaves the chatroom.  If you
# do not want it to clear out the chatroom, **CHANGE** 
# $clear_chatroom_when_empty = 1; to
# $clear_chatroom_when_empty = 0;
# By default, it will not clear out the chatroom.

$clear_chatroom_when_empty = 1;

# $log_all_chats is whether or not you want to keep a log of the chats
# over and above the "$number_of_chats_to_display" above. If you don't
# care about keeping a record of all your chat sessions, set
# $log_all_chats = "no";  Otherwise, if you'd like to be able to go
# back later for transcripts, set $log_all_chats = "yes"; and the program
# will attempt to create log files for chat transcripts. IMPORTANT!!!
# Be sure if you set this to "yes," that you also choose a logging method
# in "$type_of_log" below, the directory where you want your logs to be
# kept in $log_directory, and the maximum amount of disk space you want to
# allocate to your logs in $max_log_space. **CHANGE** this if you want to 
# keep transcripts.

$log_all_chats = "yes";

# $type_of_log has four options, described below. You should **CHANGE** this
# to the type of log you want:
# daily:   Creates a new log every day containing chat records from that day.
# monthly: Creates a new log every month.
# big:     Creates one log that gets added to forever. 

$type_of_log = "big";

# $log_directory needs to be the full system path to a directory on
# your server where you want the log/transcript files to be stored.
# On Unix/Linux-type systems, it will be something like this:
# /home/var/users/yourlogin/public_html OR
# /home/users/yourlogin/WWW  or something similar.  You should probably
# make a separate directory for these logs, something like:
# /home/var/users/yourlogin/chatlogs and chmod it 777 or otherwise so
# that the server can write to it.
# On NT and other Microsoft systems, you may need to make this something
# like:
# C:\\inetpub\\wwwroot\\yourname\\logs or  c:/inetpub/wwwroot/logs.
# DO NOT put a / or a \ on the end of this. **CHANGE** this to the
# directory where you want your logs to be stored on your system.

$log_directory = "/home/var/users/yourlogin/public_html/logs";


# $max_log_space is the amount of diskspace in bytes that you want to
# devote to logs. Note that one chat page with "$number_of_chats_to_display"
# set to "20" is about 3500 bytes, or 3.5 kilobytes.  You will need to take
# into account how much space your chat logs can take up by making sure that
# you limit it to less than the amount of disk space available to you. NOTE
# that this program will take your word for it, so if you enter something like
# 20000000 (20 megabytes) and you only have 5 megabytes available, the 
# program will happily keep logging until it uses up all your disk space
# at which point this program, and probably many others you have, may not
# work at all, you may not be able to log into your account at all, and you
# will be embarassed before your local technical support people. Currently
# the default is 1000000 or one megabyte.  **CHANGE** this to the amount
# of diskspace you want logs to be limited to.

$max_log_space = "1000000";

# $refresh_time is how often you would like the chat window to refresh
# itself.  This time is in seconds.  Note: the lower this number is,
# the faster the chat window will refresh.  For some people, this gives
# a very choppy look to the chat screen and can be hard on the eyes.
# If you make this number too high, however, then the chatroom can seem
# "dead".  **CHANGE** this to the number of seconds you'd like the room
# to wait before refreshing itself.

$refresh_time = 10;

# $idle_timeout is how long (in minutes) you would like to wait before
# automatically logging out an idle user.  Since the program can't catch
# people logging out if, e.g. their computer crashes, this can keep your
# "Who's On" log from filling up with people who left the chat room days
# before. 

$idle_timeout = "5";

# $censor_chat will try to censor some "bad words" out of the chat.
# If you want to try to censor the chat, then add words or phrases
# that you want to have censored, one per line, to badwords.txt, and
# set:
# $censor_chat = 1;
# Otherwise, set $censor_chat = 0;
# PLEASE NOTE: This program is not very intelligent as far as this
# sort of "censorship" goes.  With a bad word, say, "blah," a user
# can easily get around the censorship by typing "b l a h" or similar.
# This only cuts down on some foul language, and will not prevent
# people who are really determined to cuss from cussing in your chat
# room.

$censor_chat = 1;

# $censored_msg is what you want to show up instead of any bad words
# you might be taking out.  For example: "Blankety Blank" or "!@#%*.$".
# NOTE: This must be in SINGLE quotes, not double quotes as below.

$censored_msg = '!@#%*.$';

# $badwords_file is the full system path to your badwords.txt file
# that contains your list of bad words you want to censor out of your
# chatroom. This file should contain a list of bad words or phrases,
# one per line, and should be a plain text file.  It should begin with
# "/" on Unix/Linux systems, and perhaps "C:/" or "D:/" on Windows
# Systems.

$badwords_file = "/home/var/users/yourlogin/public_html/badwords.txt";

# $disable_special_characters_in_login is an attempt to prevent people
# from logging in with a username that contains punctuation or other
# non-word characters.  If you change this, the program will still
# attempt to remove characters such as ", ', [, ], and |, but will
# leave the rest of the login alone.  NOTE: If you set this to 0,
# then non-US-ASCII characters will be removed, so this probably wouldn't
# be a good idea to do if you are using this in a non-U.S. website.

$disable_special_characters_in_login = 1;


# $show_settings_to_user is whether or not you want your users to
# be able to see various chatroom settings, such as whether or not
# the room is censored, how long the refresh and idle timeouts are,
# etc.  If you want them to be able to view settings, leave this as it
# is. Otherwise, **CHANGE** this to:
# $show_settings_to_user = 0;

$show_settings_to_user = 1;

# $show_user_address tells us whether or not to show where the user
# is coming from when they log in.  E.g. "Kristina logged in from
# somehost.somedomain.com" or "Jojo logged in from 192.168.4.3".
# If you want to show this information, set $show_user_address = "yes";
# If you want to show only "Kristina Entered the Chatroom" set
# $show_user_address = "no";

$show_user_address = "yes";

# $path_to_chatntime_cgi is the full URL path to the chatntime.cgi
# program on your server.  This probably should begin with "http://".
# If all your files are in the same directory, you might be able to just
# leave this as it is below.  If not, **CHANGE** what's inside the ""
# to point to the chatntime.cgi file on your server.

$path_to_chatntime_cgi = "http://yourdomain.com/cgi-bin/chatntime.cgi";

# $path_to_active_users is the system path to the chatters.txt file
# which contains a list of people who are currently logged into the
# chatroom.  This file must be writeable by the web server, which
# usually means chmod 766.  This is NOT a URL, and must not start with
# "http://", but should start with a "/".  The below setting may work
# for you. If not, **CHANGE** it to the full path to where chatters.txt
# is located.

$path_to_active_users = "/home/var/users/yourlogin/public_html/chatters.txt";

# $url_of_chat_file is the full URL of the file where you 
# want the program to keep track of the conversation. (What actually
# gets shown in the chat room.)  This should also probably 
# **CHANGE** this to the url of this file on your server.

$url_of_chat_file = "http://yourdomain.com/chatntime.list.html";

# $path_to_chat_file is the full system path to the file where you 
# want the program to keep track of the conversation. (The same as
# the one we just got the URL for.)  This is NOT a URL, and must NOT
# begin with "http://".  Instead, it should probably look something
# like "/home/users/yourlogin/cgi-bin/chatntime.list.html".  **CHANGE** this to 
# the full system path of that file on your server. Again, if all your
# files are in the same directory, you may be able to leave this as-is,
# so try that first. :)

$path_to_chat_file= "/home/var/users/yourlogin/public_html/chatntime.list.html";

# $chat_goodbye_url is the full URL of the file that you'd like users
# to be directed to when they leave the chatroom. **CHANGE** this to
# the full URL of the "chat.goodbye.html" file on your server.

$chat_goodbye_url = "http://yourdomain.com/chat.goodbye.html";

# $chat_in_new_window tells the program whether to open a new browser window
# for the chat room when they log in, or whether to just leave it in the
# same window.  
# For a new window, set $chat_in_new_window = "yes";
# For the same window, set $chat_in_new_window = "no";

$chat_in_new_window = "no";

# $chat_window_header is the HTML header that you want for the page that
# contains the chat window (the window where the "conversation is".  You
# can use any HTML code you like.  HOWEVER (and this is very important)
# don't insert the initial tags <HTML><HEAD>, since this chat program
# puts them in later.  Just sort of follow the example below.  You may
# **CHANGE** this to HTML code of your choice, but be aware (and this is
# also very important) that if you use the following characters: $,@,",\
# you must put a \ (backslash) in front of them like this:
# <a href=\"http://www.whatever.net\">soandso\@wherever.net</a>

$chat_window_header = "
<title>Chat window</title>
</head>
<body bgcolor=#FFFFFF>
<strong><center>Welcome to the Chat room!</center></strong><P>
<br><br>
<b>Type /help for a list of options.</b>
<hr>
"; #<-- This quote and semicolon are necessary. Don't backslash them!

# $chat_window_footer is the HTML footer that you want for the page that
# contains the chat window (the window where the "conversation is").  You
# can use any HTML code you like.  HOWEVER, you must abide by the 
# backslashing rules as with the chat_window_header above.  **CHANGE**
# this if you wish.

$chat_window_footer = "

</body></html>

"; #<-- This quote and semicolon are necessary. Don't backslash them!

# $form_window_header is the HTML header for the frame where the form
# is that you type in to "talk".  Again, you may **CHANGE** this but
# be careful of special characters.

$form_window_header = "

<html><head><title>Chat-N-Time v2.8</title></head>
<body bgcolor=\"#FFFFFF\">

"; #<-- This quote and semicolon are necessary. Don't backslash them!

# $form_window_footer is the HTML footer for the frame where the form
# is that you type in to "talk".  Again, you may **CHANGE** this but
# be careful of special characters.

$form_window_footer = "

</body></html>

"; #<-- This quote and semicolon are necessary. Don't backslash them!

#####  End Configuration Section #####
####
#### You should not need to change anything beyond this point, but
#### you can look through it if you like that sort of thing. --kristina
########################################################################
$idle_timeout = $idle_timeout * 60;
if($chat_in_new_window eq "yes"){ $target = "_blank"; }
else{ $target = "_top"; }
# Turn debugging of if we're printing the frameset for the chat. Otherwise
# we have problems showing it.
if($data{'FA'} eq "Login"){$debugging = 0;}

&debug("Operating system is $^O") if $^O ne "";
&debug("Webserver is $ENV{'SERVER_SOFTWARE'}") if $ENV{'SERVER_SOFTWARE'} ne "";
unless(-f $path_to_chat_file){
  &debug("$path_to_chat_file does not exist or is not writeable. This will never work. Please check that \$path_to_chat_file is correctly defined in the chatntime.cgi program and that the file is writeable by the web server. This may mean you need to chmod it 766.");
  }
unless(-f $path_to_active_users){
  &debug("$path_to_active_users does not exist or is not writeable. This means that you will not be able to show users online. Please check that \$path_to_active_users is correctly defined in the chatntime.cgi program and that the file is writeable by the web server. This may mean you need to chmod it 766.");
  }
if($log_all_chats eq "yes"){
   unless(-d $log_directory){
      &debug("$log_directory does not exist or is not writeable. This means that you will not be able to keep a log of your chats.  Please check that $log_directory exists, is a directory, and is correctly set up in the program file.  Also, please make sure that it is writeable by the web server. You may need to chmod it 777.");
      $log_all_chats = "no";
   }
}

# If you remove this link, without replacing it with a similar
# HTML comment (as above in the License section) you are in violation
# of the license for this program. No, I don't have the resources to
# enforce this, and I know that some people will remove it anyway.
# But honestly, since you didn't have to pay for this, is the link
# really too much to ask? :)

$form_window_footer = "<hr><font size=-2>Chat-N-Time v2.8 
           Copyright 2001 Kristina Pfaff-Harris and can be found at 
	   <a href=http://www.tesol.net/scripts/>
           http://www.tesol.net/scripts</a>.</font>$form_window_footer";

$login = $data{'Login'}; 
if($disable_special_characters_in_login == 1){
# Take out all non-word characters
   $login =~ s/\W+//g;
   }
else {
# Take out just characters that will mess up the program.
   $login =~ s/\|//g; $login =~ s/\[//g; $login =~ s/\]//g;
   $login =~ s/\'//g; $login =~ s/\"/&quot;/g;
   $login =~ s/>/&gt;/g; $login =~ s/</&lt;/g;
   }
$time = time;

if($ENV{'REMOTE_HOST'} ne ""){ $remotehost = $ENV{'REMOTE_HOST'}; }
else { $remotehost = $ENV{'REMOTE_ADDR'}; }

# This just updates the number of users frame...
if($data{'FA'} eq "ShowUsers"){
   &show_users_online;
   exit();
   }
elsif($data{'FA'} eq "Logout"){
   &logout;
   }
elsif($data{'FA'} eq "Login"){
   &print_frameset;
   }
elsif($data{'FA'} eq "ChatMenu"){
   &print_chat_menu;
   }
elsif($data{'FA'} eq "LoginScreen"){
   &loginscreen;
   }
elsif($data{'FA'} eq "Talk"){
   &talk;
   }

sub print_chat_menu {

  print "Content-type: text/html\n\n
        $form_window_header
	<center>
        <table border=0 cellpadding=0 cellspacing=0>
	 <tr>
	  <td colspan=2 bgcolor=\"#000000\"><font size=+1 color=#FFFFFF>
	   <b>Talk to us, $login!</font></td></tr>
	   <base target=\"listen\">
	  <tr><td valign=top>
         <form name=TalkForm onSubmit=\"document.TalkForm.Sez.value=document.TalkForm.Sez2.value;document.TalkForm.Sez2.value='';\" action=\"$path_to_chatntime_cgi\" method=\"POST\">
	   <input type=hidden name=Login value=\"$login\">
	   <input type=hidden name=FA value=Talk>
	   <input type=hidden name=color value=\"$data{'color'}\">
	   <input type=text name=\"Sez2\" size=45>
	   <input type=hidden name=\"Sez\" size=45></td>
	  <td align=center>
	   <table border=1>
	    <tr>
	     <td>
	      <input tabindex=1 type=\"submit\" value=\"Talk\"></td><td>
	      <input type=reset value=\"Clear\"></center></td>
	     </form>
	     <base target=\"_top\">
	     <form target=\"_top\" action=\"$path_to_chatntime_cgi\" 
	     method=\"POST\">
	     <td>
	      <input type=hidden name=Login value=\"$data{'Login'}\">
	      <input type=hidden name=Logout value=\"yes\">
	      <input type=hidden name=FA value=\"Logout\">
	      <input type=hidden name=color value=\"$data{'color'}\">
	      <input type=submit value=Logout></td>
	     </form>
	     <base target=\"listen\">
	     <form target=\"listen\"  method=GET action=$url_of_chat_file>
	     <td>
	      <input type=hidden name=Login value=$data{'Login'}>
	      <input type=submit value=\"Refresh top\"></td>
	     </form>
	    </tr>
	   </table>
	  </td>
	 </tr>
	</table>
	$form_window_footer";
exit();
}


sub loginscreen {

  print "Content-type: text/html\n\n" if $pct != 1;
  print "$form_window_header
	<base target=$target>
	<form action=\"$path_to_chatntime_cgi\" method=\"POST\">
	<b>Please log in:</b><input type=text name=Login size=25><br>
	What color text would you like to type in?
	<table border=1>
  <tr>
   <td bgcolor=#000000>&nbsp;<input type=radio name=color value=000000 CHECKED>&nbsp;</td>
   <td bgcolor=#B5A642>&nbsp;<input type=radio name=color value=B5A642>&nbsp;
   </td>
   <td bgcolor=#5c3317>&nbsp;<input type=radio name=color value=5c3317>&nbsp;
   </td>
   <td bgcolor=#FF00FF>&nbsp;<input type=radio name=color value=FF00FF>&nbsp;
   </td>
   <td bgcolor=#800080>&nbsp;<input type=radio name=color value=800080>&nbsp;
   </td>
   <td bgcolor=#004080>&nbsp;<input type=radio name=color value=004080>&nbsp;
   </td>
   <td bgcolor=#008080>&nbsp;<input type=radio name=color value=008080>&nbsp;
   </td>
   <td bgcolor=#FF7F00>&nbsp;<input type=radio name=color value=FF7F00>&nbsp;
   </td>
   <td bgcolor=#FF0000>&nbsp;<input type=radio name=color value=FF0000>&nbsp;
   </td>
   <td bgcolor=#0000FF>&nbsp;<input type=radio name=color value=0000FF>&nbsp;
   </td>
   <td><input type=submit value=\"Log in!\"></td>
   </tr>
	<input type=hidden name=FA value=Login>
   </table></form>
   $form_window_footer";
   exit();
}

sub talk {

  &get_date;
  $data{'Sez'} =~ s/^\s+//g; $data{'Sez'} =~ s/\s+$//g;
  $data{'Sez2'} =~ s/^\s+//g; $data{'Sez2'} =~ s/\s+$//g;
  if($data{'Sez'} eq ""){$data{'Sez'} = $data{'Sez2'};}

  # Check if logged in
  open(CHATTERS, "<$path_to_active_users") || 
    &debug("Can't open $path_to_active users (active users file) for reading: $!");
    $ison = (grep(/^$login\|$remotehost\|/, <CHATTERS>))[0];
  close(CHATTERS);

  $ison =~ s/\s+$//g;
  if($ison ne ""){ $loggedin = 1; }
  if($loggedin != 1){
  # If not, add to chatters. 
     open(CHATTERS, ">>$path_to_active_users") || 
     &debug("Can't open $path_to_active_users (active users) for writing: $!");
     if($^O !~ /win/i){
       flock(CHATTERS, 2);
       }
     else {
       binmode(CHATTERS);
       }
       seek(CHATTERS, 0, 2);
       

     print CHATTERS "$login|$remotehost|$time|$data{'color'}\n";
       
     if($^O !~ /win/i){ flock(CHATTERS, 8); }
     close(CHATTERS);
     
     }
  # If so, update time.
  else {
       ($f_login,$f_remote,$f_time,$f_color) = split(/\|/, $ison);
        $time = time;
	open(CHATTERS, "+<$path_to_active_users") ||
	  &debug("Can't open $path_to_active_users for read/write: $!");
        if($^O !~ /win/i){
	 flock(CHATTERS, 2);
	 }
        else{
          binmode(CHATTERS);
          }
	@chatters = <CHATTERS>;
        
	foreach $chatter (@chatters){
          $chatter =~ s/\s+$//g;
          if($chatter =~ /^$f_login\|/){
             $nchatter .= "$f_login|$f_remote|$time|$f_color\n";
             }
          else {
             $nchatter .= "$chatter\n";
             }
          }
	truncate(CHATTERS, length($nchatter));
	# Rewind to the beginning of the file...
	seek(CHATTERS, 0, 0);
	print CHATTERS $nchatter;
	close(CHATTERS);
        &check_idle_timeouts;
  }
  if($data{'Sez'} eq ""){$text = "&lt;just sitting here&gt;";}
  else { $text = $data{'Sez'}; }
  if($loggedin != 1){
    if($show_user_address eq "yes"){
       $text = "&lt;Logged on from $remotehost.&gt; $text";
       }
    else{ 
       $text = "&lt;Entered the chatroom.&gt; $text"; 
       }
    }
  # Add to chat file.
  &write_to_chat_file($login,$remotehost,$text);
  
  # Now display it...
  # Get the contents of that file into a variable.  Could also have used
  # $file = `cat list.html`;

  open(FILE, "<$path_to_chat_file") || 
  &debug("Can't open $path_to_chat_file for reading: $!"); 
  print "Content-type: text/html\n\n" if $pct != 1;
  while(<FILE>){ print;} 
  close(FILE); 
  $/="\n";
  exit();
}


sub get_date {
   if($_[0] eq ""){$testtime = time;}
   else{$testtime = $_[0];}

   ($sec,$min,$hour,$mday,$mon,$year) = (localtime($testtime))[0,1,2,3,4,5];
   $mon = $mon + 1;
   if ($hour < 10) { $hour = "0$hour"; }
   if ($min < 10) { $min = "0$min"; }
   if ($sec < 10) { $sec = "0$sec"; }
   $year += 1900;
   $date = "$mon/$mday/$year $hour\:$min\:$sec";
   $date;
}

sub show_users_online {

print "Content-type: text/html\n\n";

&check_idle_timeouts;

print "<HTML><HEAD><META HTTP-EQUIV=Refresh Content=\"$refresh_time;URL=$path_to_chatntime_cgi?FA=ShowUsers\"><META HTTP-EQUIV=\"Expires\" CONTENT=\"0\"></head>\n<body bgcolor=#FFFFFF>

";
$users_online .= "<table border=1>
       <tr><th>Login</th><th>Idle since:</th></tr>\n";

open(FILE, "<$path_to_active_users") || &debug("Can't find $path_to_active_users.");
 @clines = <FILE>;
 foreach $cline (@clines){

   ($show_user,$show_remote_host,$time_on,$color)=split(/\|/, $cline);
   ($show_user,$blah) = &check_badwords($show_user,"blah");
   $date = &get_date($time_on);
   chomp($color);
   $color =~ s/\s+$//g;
   $users_online .= "<tr><td><font color=\"#$color\">$show_user</font></td>
	  <td><font size=-2><font color=\"#$color\">$date</font></font></td></tr>\n";
   $found_users = $found_users + 1;
	  }
close(FILE);

$users_online_header = "<html><head></head><body bgcolor=#FFFFFF>
       Users Currently Online:<br><br>\n";
  if($found_users == 0){
     $users_online .= "<tr><td colspan=2>The Chatroom is empty.</td></tr>\n";
     if($clear_chatroom_when_empty == 1){
          &clear_chatroom;
       }
     }
  else{
     if($found_users == 1){
	$isare = "is"; $user_s = "user";
	}
     else{
	$isare = "are"; $user_s = "users";
	}
     $kphdate = &get_date;
     print "<html><head><title>Users Online</title></head>
	    <body bgcolor=#FFFFFF>
	    <tr><td colspan=2><center>$found_users $user_s <!-- $isare currently --> online<br>
	    Chatroom time: <br> $kphdate</center>
	    </td></tr>\n";
        }
  print "$users_online</table>";
  print "<font size=-1><a target=\"show\" href=\"$path_to_chatntime_cgi?FA=ShowUsers\">[&nbsp;Update&nbsp;Who's&nbsp;Online&nbsp;]</a></font></body></html>";

#	 <base target=\"show\">
#	 <form method=POST action=$path_to_chatntime_cgi>
#	 <input type=hidden name=FA value=ShowUsers>
#	 <input type=submit value=\"Show Users\"></form> the program will still
# attempt to remove characters such as ", ', [, ], and |, but will
# leave the rest of the login alone.  NOTE: If you set this to 0,
# then non-US-ASCII characters will be removed, so this probably wouldn't
# be a good idea to do if you are using this in a non-U.S. website.
##	 </body></html>";

}


sub get_data {
    local($string);

    # get data
    if ($ENV{'REQUEST_METHOD'} eq 'GET') {
        $string = $ENV{'QUERY_STRING'};
    }				
    else { read(STDIN, $string, $ENV{'CONTENT_LENGTH'}); }

    # split data into name=value pairs
    @data = split(/&/, $string);
   
    # split into name=value pairs in associative array
    foreach (@data) {
	split(/=/, $_);
	$_[0] =~ s/\+/ /g; # plus to space
        $_[0] =~ s/%0D%0A%0D%0A/\n\n/g; #added by kristina make newlines?
        $_[0] =~ s/%0a/newline/g;
        $_[0] =~ s/\%00//g;
	$_[0] =~ s/%(..)/pack("c", hex($1))/ge; # hex to alphanumeric
	if(defined($data{$_[0]})){ 
	   $data{$_[0]} .= "\0";
	   $data{$_[0]} .= "$_[1]";
	   }
	else {
	$data{"$_[0]"} = $_[1];
	  }
    }
    # translate special characters
    foreach (keys %data) {
	$data{"$_"} =~ s/\+/ /g; # plus to space
	$data{"$_"} =~ s/%(..)/pack("c", hex($1))/ge; # hex to alphanumeric
        $data{"$_"} =~ s/\%00//g;
    }

    %data;			# return associative array of name=value
}

sub debug {

if($debugging == 1){
  print "Content-type: text/html\n\n" if $pct != 1;
  $pct = 1;
  print "$_[0]<br>\n";
  }
}

sub print_frameset {

# Subroutine to just draw the frameset on login:
# I need to have $login
print "Content-type: text/html\n\n";

if($login eq "" || $login =~ /^\s+$/){
   print "$header
	  <b>Error: Invalid login ($data{'Login'}).</b>
	  <br><br>
	  Your login cannot contain punctuation or special characters.
	  Please <a onClick=\"javascript:history.back();\"
	  href=$ENV{'HTTP_REFERER'}>Go back and try again.
	  </a>
	  $footer";
   exit();
   }
print <<EOF;
       $header
       <frameset rows="*,110" border=0 
	onUnload="window.location='$ENV{'SCRIPT_NAME'}?FA=Logout&Login=$login'">
       <frameset cols="80%,*" border=0> 
       <frame src="$url_of_chat_file" name="listen">
       <frame src="$ENV{'SCRIPT_NAME'}?FA=ShowUsers" name="show">
       </frameset>
       <frame src="$ENV{'SCRIPT_NAME'}?FA=ChatMenu&Login=$login&color=$data{'color'}" name="talk" scrolling=auto> 
       </frameset>
       $footer
EOF
 open(CHATTERS, ">>$path_to_active_users") || 
 &debug("Can't open $path_to_active_users (active users) for writing: $!");
 if($^O !~ /win/i){flock(CHATTERS, 2);}
 else{ binmode(CHATTERS);}
 seek(CHATTERS, 0, 2); 

 print CHATTERS "$login|$remotehost|$time|$data{'color'}\n";
 if($^O !~ /win/i){flock(CHATTERS, 8); }
 close(CHATTERS);
 
 if($show_user_address eq "yes"){$text = "&lt;Logged on from $remotehost.&gt;";}
 else{ $text = "&lt;Entered the chat room.&gt;"; }
 &write_to_chat_file($login,$remotehost,"$text");

       exit();

}


sub logout {

 open(FILE, "+<$path_to_active_users"); 
 binmode(FILE);
  @lines = <FILE>;
 if($^O !~ /win/i){flock(FILE, 2);}

 foreach $line (@lines){
   $line =~ s/\s+$//g;
   if($line !~ /^$login\|/){
      $nfile .= "$line\n";
      }
   }
 truncate(FILE, length($nfile));
 seek(FILE, 0, 0);
 print FILE "$nfile";
 close(FILE);
 &write_to_chat_file($login,$remotehost,"&lt;Left the chatroom.&gt;") 
  if $data{'color'} ne "";
 if(length($nfile) == 0 && $clear_chatroom_when_empty == 1){
   &clear_chatroom;
   }

 print "Location: $chat_goodbye_url\n\n";
 exit();

}

sub write_to_chat_file {

my($login) = $_[0];
my($ip) = $_[1];
my($message) = $_[2];
my($text) = $_[2];
my($date) = &get_date();

  undef $/; 
  open(FILE, "+<$path_to_chat_file") || 
   &debug("Cannot open $path_to_chat_file (chat file) for read/write: $!");
  # Try to open a file that holds the statements everyone has been making
  # and lock it...
  if($^O !~ /win/i){
   flock(FILE, 2);
   }
  else{
    binmode(FILE);
    }

 # We assume that there is <!-- Statement --> between each "statement" 
 # because we put it there. :)

    @entries = split("<!-- Statement -->", <FILE>); 

# Now, we can get any entry in "@entries" by calling them by number.
# this way, we can print only $number_of_chats_to_display to the file later.

# Now, we've opened the file, but let's make sure it refreshes the next time.

  $newhtml = "<HTML><HEAD>
	     <META HTTP-EQUIV=Refresh Content=\"$refresh_time;URL=$url_of_chat_file\">
	     $chat_window_header
	     <!-- center><table border=1 width=100%>
	     <tr><td --><!-- Statement -->";

# Don't allow them to put in html code if we don't want them to...
   if($disable_html == 1){
      $login =~ s/</&lt;/g; $login =~ s/>/&gt;/g;
      $text =~ s/</&lt;/gs; $text =~ s/>/&gt;/gs;
      }

  $clogin = $login; $ctext = $text;
# Check for "bad words". :)
  ($clogin,$ctext) = &check_badwords($clogin,$ctext);
  
# must get rid of " in the message...
# Make their message in a happy color with date and stuff...
# See if they did "/me" or "/login" and treat that accordingly.
   if($ctext =~ /^\/me/i || $ctext =~ /^\/$login/i){
      $ctext =~ s/^\/me//;
      $ctext =~ s/^\/$login//;
      $ctext = "[$date] <font color=\"#$data{'color'}\"><strong>$clogin $ctext</strong></font><br>";
      }
   elsif($ctext =~ /^\/yell/i){
      $ctext =~ s/^\/yell//i;
      $ctext =~ s/^\s+//ig;
      $ctext =~ tr/[a-z]/[A-Z]/;
      $ctext = "[$date] <font color=\"#$data{'color'}\"><strong>$clogin yells, \"$ctext\"</strong></font><br>";



   }
# Trying settings
   elsif($ctext =~ /^\/settings/i){
      $unique = $$;
      $fname = $login; $fname =~ s/\W+//g;
      if($show_settings_to_user == 1){
      if($disable_special_characters_in_login == 1){$cdisspl = "Disabled";}
      else{$cdisspl = "Enabled";}
      if($disable_html == 1){ $cdisable_html = "Disabled"; }
      else { $cdisable_html = "Enabled"; }
      if($clear_chatroom_when_empty == 1){ $emptyout = "Enabled"; }
      else { $emptyout = "Disabled"; }
      if($log_all_chats eq "yes"){ $clogging = "Enabled"; }
      else { $clogging = "Disabled"; }
      if($show_user_address eq "yes"){ $showaddr = "Enabled"; }
      else { $showaddr = "Disabled"; }
      if($censor_chat == 1){$ccensor = "Enabled";}
      else{$ccensor = "Disabled";}
      $ctext = "\n<script language=\"JavaScript\">
      write${unique}settingsto$fname();
      function write${unique}settingsto$fname () {
	if(parent.talk == null){return;}
	if(parent.talk.document == null){return;}
	if(parent.talk.document.TalkForm == null){return;}
	if(parent.talk.document.TalkForm.Login == null){return;}
      if(parent.talk.document.TalkForm.Login.value == \"$clogin\"){
	document.write(\"<table border=0><tr><td colspan=2><strong>Chatroom settings:</strong></td></tr><tr><td><dd><b>User HTML</b></td><td>$cdisable_html</td></tr><tr><td><dd><b>Lines of Chat displayed:</b></td><td>$number_of_chats_to_display</td></tr><tr><td><dd><b>Clear Chatroom When Empty:</b></td><td>$emptyout</td></tr><tr><td><b><dd>Chat Logging:</b></td><td>$clogging</td></tr><tr><td><b><dd>Refresh Time:</b></td><td>$refresh_time seconds</td></tr><tr><td><b><dd>Idle Timeout:</b></td><td>$idle_time_min minutes</td></tr><tr><td><b><dd>Show User Address on Login:</b></td><td>$showaddr</td></tr><tr><td><b><dd>Allow Special Characters in Login Name:</b></td><td>$cdisspl</td></tr><tr><td><b><dd>Chat Censoring:</b></td><td>$ccensor</td></tr></table>\");
       }
       return;
      }
      </script>\n";
      }
      else {
        $ctext = "\n<script language=\"JavaScript\">
        write${unique}settingsto$fname();
        function write${unique}settingsto$fname () {
	if(parent.talk == null){return;}
	if(parent.talk.document == null){return;}
	if(parent.talk.document.TalkForm == null){return;}
	if(parent.talk.document.TalkForm.Login == null){return;}
        if(parent.talk.document.TalkForm.Login.value == \"$clogin\"){
	document.write(\"Sorry, but the owner has disabled the /settings command.<br>\");
         }
        return;
        }
        </script>\n";
        }
      }
   elsif($ctext =~ /^\/msg/i || $ctext =~ /^\/whisper/i){
      $ctext =~ s/\"/\\\"/g;
      $unique = $$;
      $fname = $login; $fname =~ s/\W+//g;
      $ctext =~ s/^\/msg//i;
      $ctext =~ s/^\/whisper//i;
      $tologin = $ctext; 
      $tologin =~ s/^\s+//g;$tologin =~ s/\s+$//g;
      $tologin =~ s/(.*?)(\s+)(.*)/$1/;
      $tomsg = $ctext; 
      $tomsg =~ s/^\/msg $tologin//;
      $tomsg =~ s/^\s+$tologin//;
      $tomsg =~ s/^$tologin//;
      $ctext = "\n<script language=\"JavaScript\">
      write${unique}msg();
      function write${unique}msg () {
	if(parent.talk == null){return;}
	if(parent.talk.document == null){return;}
	if(parent.talk.document.TalkForm == null){return;}
	if(parent.talk.document.TalkForm.Login == null){return;}
        if(parent.talk.document.TalkForm.Login.value == \"$tologin\"){
	  var text${unique} = \"<table border=0><tr><td>[$date] <font color=\\\"#$data{'color'}\\\">\";
	  text${unique} = text${unique} + \"<strong> \\[Private Msg from $clogin\\]\";
	  text${unique} = text${unique} + \"$tomsg\";
	  text${unique} = text${unique} + \"</strong></font></td></tr></table>\";
	  document.write(text${unique});
        }
        if(parent.talk.document.TalkForm.Login.value == \"$clogin\"){
	  var text${unique} = \"<table border=0><tr><td>[$date] <font color=\\\"#$data{'color'}\\\">\";
	  text${unique} = text${unique} + \"<strong> \\[Private Msg to $tologin\\]\";
	  text${unique} = text${unique} + \"$tomsg\";
	  text${unique} = text${unique} + \"</strong></font></td></tr></table>\";
	document.write(text${unique});
	}
       return;
      }
      </script>";
   }
   elsif($ctext =~ /^\/help/i){
      $ctext =~ s/\"/\\\"/g;
      $unique = $$;
      $fname = $login; $fname =~ s/\W+//g;
      $ctext =~ s/^\/help//i;
      $ctext = "\n<script language=\"JavaScript\">
      write${unique}helpto$fname();
      function write${unique}helpto$fname () {
	if(parent.talk == null){return;}
	if(parent.talk.document == null){return;}
	if(parent.talk.document.TalkForm == null){return;}
	if(parent.talk.document.TalkForm.Login == null){return;}
      if(parent.talk.document.TalkForm.Login.value == \"$clogin\"){
	document.write(\"<table border=0><tr><td colspan=2><strong>Chatroom options:</strong></td></tr><tr><td><dd><b>/help</b></td><td>Shows this message</td></tr><tr><td><dd><b>/msg &lt;login&gt; &lt;Message&gt;</b></td><td>Sends a private message to &lt;login&gt;</td></tr><tr><td><dd><b>/whisper &lt;login&gt; &lt;Message&gt;</b></td><td>Same as /msg.</td></tr><tr><td><dd><b>/me &lt;does something&gt;</b></td><td>\\\"Emote\\\": Shows \\\"YourLogin does something\\\"</td></tr><tr><td><b><dd>/$login &lt;does something&gt;</b></td><td>Same as \\\"/me\\\"</td></tr><tr><td><b><dd>/yell &lt;some message&gt;</b></td><td>Shows \\\"YourLogin yells, \\\"SOME MESSAGE\\\"</td></tr><tr><td><b><dd>/settings</b></td><td>Shows current chat room settings</td></tr></table>\");
       }
       return;
      }
      </script>\n";
   }
   else {
     $ctext = "[$date] <strong>$clogin:</strong><font color=\"#$data{'color'}\"> <b> $ctext</b></font><br>";
     }

# Put the new info in.
     $newhtml .= "$ctext";
     $newhtml .= "<!-- Statement -->\n";

  
# Now, we're going to step through the previous entries, and print them
# back to the file:

# Starting with 1, until $i is equal to 10, add 1 to $i and keep looping...
  for($i = 1; $i <= $number_of_chats_to_display; $i++){
     if($entries[$i] !~ /$chat_window_footer/){
	$entries[$i] =~ s/\n//gs;
	$newhtml .= "$entries[$i]<!-- Statement -->\n" if $entries[$i] ne "";
	}
  }
  # Close the document cleanly.
  $newhtml .= "<!-- /td></tr></table -->$chat_window_footer";
  truncate(FILE, length($newhtml));
  seek(FILE, 0, 0);
  print FILE $newhtml;
  close(FILE);
  $/ = "\n";
# Log it if they want a transcript...
     &log("$text") if $log_all_chats eq "yes";  
}

sub clear_chatroom {

  undef $/; 
  open(FILE, "$path_to_chat_file") || 
   &debug("Cannot open $path_to_chat_file (chat file) for reading: $!");
 # We assume that there is <!-- Statement --> between each "statement" 
 # because we put it there. :)
    @entries = split("<!-- Statement -->", <FILE>); 
  close(FILE); 
  $/ = "\n";
  $i = 0;
  foreach $entry (@entries){
    if($entry =~ /table border/ && $entries[$i + 1] =~ /Chatroom unused/){
      $already_cleared = 1;
      last;
      }
    $i++;
  }
  if($already_cleared != 1){
    
# Now, we can get any entry in "@entries" by calling them by number.
# this way, we can print only $number_of_chats_to_display to the file later.
  $date = &get_date();
  # Try to open a file that holds the statements everyone has been making
  # and lock it...
  open(FILE, ">$path_to_chat_file") || 
   &debug("Cannot open $path_to_chat_file for writing: $!");
  if($^O !~ /win/i){
   flock(FILE, 2);
   }
  else{
    binmode(FILE);
    }
# Now, we've opened the file, but let's make sure it refreshes the next time.

  print FILE "<HTML><HEAD>
	     <META HTTP-EQUIV=Refresh Content=\"$refresh_time;URL=$url_of_chat_file\">
	     $chat_window_header
	     <center><table border=1 width=100%>
	     <tr><td><!-- Statement -->";

# Put the new info in.
     print FILE "<b><i>Chatroom unused since $date</i></b>";
     print FILE "<!-- Statement -->\n";

  
# Now, we're going to step through the previous entries, and print them
# back to the file:

# Starting with 1, until $i is equal to 10, add 1 to $i and keep looping...
  for($i = 1; $i <= $number_of_chats_to_display; $i++){
     if($entries[$i] !~ /$chat_window_footer/){
	$entries[$i] =~ s/\n//gs;
	print FILE "<br><!-- Statement -->\n";
	}
  }
  # Close the document cleanly.
  print FILE "</td></tr></table>$chat_window_footer";
  close(FILE);
  $/ = "\n";
  }
}

sub check_idle_timeouts {

# What the hey: let's check for people we should auto-timeout here
# too.
my $time = time;
my($line, @chatters,$one,$two,$stuff);

open(CHATTERS, "+<$path_to_active_users") || 
 &debug("Can't open $path_to_active_users (active users file): $!");
if($^O !~ /win/i){
 flock(CHATTERS, 2);
 }
else{
 binmode(CHATTERS);
 }
 @chatters = <CHATTERS>;
 foreach $line (@chatters){
    $line =~ s/\s+$//g;
    ($f_l,$f_rh,$f_t,$f_c) = split(/\|/, $line);
    $ntime = $f_t + $idle_timeout;

     if(($f_t + $idle_timeout) >= $time){
	 $one = $f_t + $idle_timeout; $two = $time;
	 $stuff .= "$line\n";
	 }
     else{
       $data{'color'} = $f_c;
       chomp($f_c);
       &write_to_chat_file($f_l,$f_rh,"&lt;Left the chatroom (autologout).&gt;");
	}
    }
 truncate(CHATTERS, length($stuff));
 seek(CHATTERS, 0, 0);
 print FILE $stuff;
 close(CHATTERS);
 if(length($stuff) == 0 && $clear_chatroom_when_empty == 1){
   &clear_chatroom;
   }
 
}

sub log {

   $text = $_[0];
   ($mday,$mon,$year) = (localtime(time))[3,4,5];
    $mon += 1; $year += 1900;
   opendir(DIR, "$log_directory"); @files = readdir(DIR); closedir(DIR);
   foreach $file (@files){
     if(-f $file && $file =~ /^chatntime-log/){
        $logsize += (stat($file))[7];
	}
     }
   undef @files;
	
  if($type_of_log eq "daily"){ $file = "chatntime-log-$mday-$mon-$year.html"; }
  elsif($type_of_log eq "monthly"){ $file = "chatntime-log-$mon-$year.html"; }
  else{ $file = "chatntime-log.html";}

  if($logsize <= $max_log_space){
    open(FILE, ">>$log_directory/$file") || 
      &debug("Can't open file $log_directory/$log to log chat $!"); 
    if($^O !~ /win/i){ flock(FILE, 2);}
    else { binmode(FILE);}
    seek(FILE, 0, 2); 
    
    print FILE "$text\n";
    close(FILE);
    }
}

sub check_badwords {

my($clogin,$ctext) = @_;

  if($censor_chat == 1){
  $/ = "\n";
  open(BW, "<$badwords_file") ||
   &debug("Could not open $badwords file! $! This chat will not be censored.");
   @badwords = grep(!/^#/,<BW>);
  close(BW);
  foreach $badword (@badwords){
    chomp($badword);
    $clogin =~ s/$badword/\[$censored_msg\]/ig;
    $ctext =~ s/$badword/\[$censored_msg\]/ig;
    }
   }
 my(@results) = ($clogin,$ctext);
 @results;

}
